using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Data;
using System.IO;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

using iclect.Forms.Utility;

namespace iclect.Forms
{
	/// <summary>
	/// Summary description for AddressBar.
	/// </summary>
	public class AddressBar : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.ComboBox comboBoxFolder;
		private System.Windows.Forms.ImageList imageListNavigation;
		private System.Windows.Forms.ToolBar toolBarNavigation;
		private System.Windows.Forms.ToolBarButton toolBarButtonGo;
		private System.Windows.Forms.ToolBarButton toolBarButtonUp;
		private System.Windows.Forms.ToolBarButton toolBarButtonOpen;
		private System.Windows.Forms.ContextMenu contextMenuFolderText;
		private System.Windows.Forms.MenuItem menuItemFolderEditCut;
		private System.Windows.Forms.MenuItem menuItemFolderEditCopy;
		private System.Windows.Forms.MenuItem menuItemFolderEditPaste;
		private System.Windows.Forms.MenuItem menuItemFolderEditDelete;
		private System.Windows.Forms.MenuItem menuItemFolderEditSelectAll;
		private System.Windows.Forms.MenuItem menuItemFolderSep2;
		private System.Windows.Forms.MenuItem menuItemFolderSep3;
		private System.Windows.Forms.MenuItem menuItemFolderGo;
		private System.Windows.Forms.MenuItem menuItemFolderUp;
		private System.Windows.Forms.MenuItem menuItemFolderOpen;
		private System.Windows.Forms.ContextMenu contextMenuFolderList;
		private System.ComponentModel.IContainer components;
		private iclect.Forms.Utility.MenuItemHelp menuItemHelp;

		public AddressBar()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AddressBar));
			this.comboBoxFolder = new System.Windows.Forms.ComboBox();
			this.contextMenuFolderText = new System.Windows.Forms.ContextMenu();
			this.menuItemFolderEditCut = new System.Windows.Forms.MenuItem();
			this.menuItemFolderEditCopy = new System.Windows.Forms.MenuItem();
			this.menuItemFolderEditPaste = new System.Windows.Forms.MenuItem();
			this.menuItemFolderEditDelete = new System.Windows.Forms.MenuItem();
			this.menuItemFolderSep2 = new System.Windows.Forms.MenuItem();
			this.menuItemFolderEditSelectAll = new System.Windows.Forms.MenuItem();
			this.menuItemFolderSep3 = new System.Windows.Forms.MenuItem();
			this.menuItemFolderUp = new System.Windows.Forms.MenuItem();
			this.menuItemFolderGo = new System.Windows.Forms.MenuItem();
			this.menuItemFolderOpen = new System.Windows.Forms.MenuItem();
			this.imageListNavigation = new System.Windows.Forms.ImageList(this.components);
			this.toolBarNavigation = new System.Windows.Forms.ToolBar();
			this.toolBarButtonGo = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonUp = new System.Windows.Forms.ToolBarButton();
			this.toolBarButtonOpen = new System.Windows.Forms.ToolBarButton();
			this.contextMenuFolderList = new System.Windows.Forms.ContextMenu();
			this.menuItemHelp = new iclect.Forms.Utility.MenuItemHelp(this.components);
			this.SuspendLayout();
			// 
			// comboBoxFolder
			// 
			this.comboBoxFolder.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.comboBoxFolder.ContextMenu = this.contextMenuFolderText;
			this.comboBoxFolder.Location = new System.Drawing.Point(0, 1);
			this.comboBoxFolder.MaxDropDownItems = 20;
			this.comboBoxFolder.Name = "comboBoxFolder";
			this.comboBoxFolder.Size = new System.Drawing.Size(336, 21);
			this.comboBoxFolder.TabIndex = 1;
			this.comboBoxFolder.DropDown += new System.EventHandler(this.OnFolderDropDown);
			this.comboBoxFolder.SelectedIndexChanged += new System.EventHandler(this.OnFolderIndexChanged);
			// 
			// contextMenuFolderText
			// 
			this.contextMenuFolderText.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								  this.menuItemFolderEditCut,
																								  this.menuItemFolderEditCopy,
																								  this.menuItemFolderEditPaste,
																								  this.menuItemFolderEditDelete,
																								  this.menuItemFolderSep2,
																								  this.menuItemFolderEditSelectAll,
																								  this.menuItemFolderSep3,
																								  this.menuItemFolderUp,
																								  this.menuItemFolderGo,
																								  this.menuItemFolderOpen});
			this.contextMenuFolderText.Popup += new System.EventHandler(this.OnFolderTextPopup);
			// 
			// menuItemFolderEditCut
			// 
			this.menuItemHelp.SetHelpText(this.menuItemFolderEditCut, "Cut the selected text.");
			this.menuItemFolderEditCut.Index = 0;
			this.menuItemFolderEditCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.menuItemFolderEditCut.Text = "Cu&t";
			this.menuItemFolderEditCut.Click += new System.EventHandler(this.OnFolderEditCut);
			// 
			// menuItemFolderEditCopy
			// 
			this.menuItemHelp.SetHelpText(this.menuItemFolderEditCopy, "Copy the selected text to the clipboard.");
			this.menuItemFolderEditCopy.Index = 1;
			this.menuItemFolderEditCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.menuItemFolderEditCopy.Text = "&Copy";
			this.menuItemFolderEditCopy.Click += new System.EventHandler(this.OnFolderEditCopy);
			// 
			// menuItemFolderEditPaste
			// 
			this.menuItemHelp.SetHelpText(this.menuItemFolderEditPaste, "Paste text from the clipboard, replacing the current selection.");
			this.menuItemFolderEditPaste.Index = 2;
			this.menuItemFolderEditPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.menuItemFolderEditPaste.Text = "&Paste";
			this.menuItemFolderEditPaste.Click += new System.EventHandler(this.OnFolderEditPaste);
			// 
			// menuItemFolderEditDelete
			// 
			this.menuItemHelp.SetHelpText(this.menuItemFolderEditDelete, "Delete the selected text.");
			this.menuItemFolderEditDelete.Index = 3;
			this.menuItemFolderEditDelete.Shortcut = System.Windows.Forms.Shortcut.Del;
			this.menuItemFolderEditDelete.Text = "&Delete";
			this.menuItemFolderEditDelete.Click += new System.EventHandler(this.OnFolderEditDelete);
			// 
			// menuItemFolderSep2
			// 
			this.menuItemFolderSep2.Index = 4;
			this.menuItemFolderSep2.Text = "-";
			// 
			// menuItemFolderEditSelectAll
			// 
			this.menuItemHelp.SetHelpText(this.menuItemFolderEditSelectAll, "Select all text.");
			this.menuItemFolderEditSelectAll.Index = 5;
			this.menuItemFolderEditSelectAll.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
			this.menuItemFolderEditSelectAll.Text = "Select &All";
			this.menuItemFolderEditSelectAll.Click += new System.EventHandler(this.OnFolderEditSelectAll);
			// 
			// menuItemFolderSep3
			// 
			this.menuItemFolderSep3.Index = 6;
			this.menuItemFolderSep3.Text = "-";
			// 
			// menuItemFolderUp
			// 
			this.menuItemHelp.SetHelpText(this.menuItemFolderUp, "Navigate up one level.");
			this.menuItemFolderUp.Index = 7;
			this.menuItemFolderUp.Shortcut = System.Windows.Forms.Shortcut.AltBksp;
			this.menuItemFolderUp.Text = "&Up one level";
			this.menuItemFolderUp.Click += new System.EventHandler(this.OnFolderUp);
			// 
			// menuItemFolderGo
			// 
			this.menuItemHelp.SetHelpText(this.menuItemFolderGo, "Go to folder.");
			this.menuItemFolderGo.Index = 8;
			this.menuItemFolderGo.Text = "&Go";
			this.menuItemFolderGo.Visible = false;
			this.menuItemFolderGo.Click += new System.EventHandler(this.OnFolderGo);
			// 
			// menuItemFolderOpen
			// 
			this.menuItemHelp.SetHelpText(this.menuItemFolderOpen, "Open a folder.");
			this.menuItemFolderOpen.Index = 9;
			this.menuItemFolderOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.menuItemFolderOpen.Text = "&Open...";
			this.menuItemFolderOpen.Visible = false;
			this.menuItemFolderOpen.Click += new System.EventHandler(this.OnFolderOpen);
			// 
			// imageListNavigation
			// 
			this.imageListNavigation.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageListNavigation.ImageSize = new System.Drawing.Size(16, 16);
			this.imageListNavigation.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageListNavigation.ImageStream")));
			this.imageListNavigation.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// toolBarNavigation
			// 
			this.toolBarNavigation.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.toolBarNavigation.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBarNavigation.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																								 this.toolBarButtonGo,
																								 this.toolBarButtonUp,
																								 this.toolBarButtonOpen});
			this.toolBarNavigation.Divider = false;
			this.toolBarNavigation.Dock = System.Windows.Forms.DockStyle.None;
			this.toolBarNavigation.DropDownArrows = true;
			this.toolBarNavigation.ImageList = this.imageListNavigation;
			this.toolBarNavigation.Location = new System.Drawing.Point(336, 0);
			this.toolBarNavigation.Name = "toolBarNavigation";
			this.toolBarNavigation.ShowToolTips = true;
			this.toolBarNavigation.Size = new System.Drawing.Size(112, 23);
			this.toolBarNavigation.TabIndex = 2;
			this.toolBarNavigation.TextAlign = System.Windows.Forms.ToolBarTextAlign.Right;
			this.toolBarNavigation.Wrappable = false;
			this.toolBarNavigation.ButtonDropDown += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.OnDropDown);
			this.toolBarNavigation.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.OnNavigation);
			// 
			// toolBarButtonGo
			// 
			this.toolBarButtonGo.ImageIndex = 0;
			this.toolBarButtonGo.Tag = this.menuItemFolderGo;
			this.toolBarButtonGo.Text = "Go";
			this.toolBarButtonGo.ToolTipText = "Go to folder.";
			// 
			// toolBarButtonUp
			// 
			this.toolBarButtonUp.ImageIndex = 1;
			this.toolBarButtonUp.Tag = this.menuItemFolderUp;
			this.toolBarButtonUp.ToolTipText = "Navigate to the parent folder.";
			// 
			// toolBarButtonOpen
			// 
			this.toolBarButtonOpen.DropDownMenu = this.contextMenuFolderList;
			this.toolBarButtonOpen.ImageIndex = 2;
			this.toolBarButtonOpen.Style = System.Windows.Forms.ToolBarButtonStyle.DropDownButton;
			this.toolBarButtonOpen.Tag = this.menuItemFolderOpen;
			this.toolBarButtonOpen.ToolTipText = "Open a folder from the list.";
			// 
			// AddressBar
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.toolBarNavigation,
																		  this.comboBoxFolder});
			this.Name = "AddressBar";
			this.Size = new System.Drawing.Size(448, 23);
			this.Load += new System.EventHandler(this.OnFolderGo);
			this.ResumeLayout(false);

		}
		#endregion

		string _currentFolder = null;
		public void GoToFolder(string folder)
		{
			if (folder == null)
				folder = string.Empty;
			else
				folder = folder.Trim();

			bool exists						= false;
			bool canUp						= false;

			if (folder != string.Empty)
			{
				DirectoryInfo dir				= new DirectoryInfo(folder);
				folder							= dir.FullName;
				exists							= dir.Exists;
				canUp							= exists && (dir.Parent != null);
			}

			this.toolBarButtonUp.Enabled	= canUp;
			this.menuItemFolderUp.Enabled	= canUp;
			this.comboBoxFolder.Text		= folder;
			this.comboBoxFolder.Select(folder.Length, 0);

			if (folder != _currentFolder)
			{
				_currentFolder = folder;
				FireFolderChanged(folder);
			}
		}

		private void OnNavigation(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			System.Windows.Forms.MenuItem menuItem = e.Button.Tag as System.Windows.Forms.MenuItem;
			if (menuItem != null)
				menuItem.PerformClick();
		}

		private void OnFolderGo(object sender, System.EventArgs e)
		{
			GoToFolder(this.comboBoxFolder.Text);
		}

		private void OnFolderUp(object sender, System.EventArgs e)
		{
			string folder = this.comboBoxFolder.Text;
			if ((folder.IndexOf(Path.DirectorySeparatorChar) >= 0)
				&& Directory.Exists(folder))
			{
				DirectoryInfo dir = new DirectoryInfo(folder);
				if (dir.Parent != null)
					GoToFolder(dir.Parent.FullName);
			}
		}

		public void OpenFolderDialog()
		{
			iclect.Forms.Utility.FolderBrowserDialog dlg = new iclect.Forms.Utility.FolderBrowserDialog();
			if (this.comboBoxFolder.Text == string.Empty)
				dlg.SelectedPath		= GetMyPicturesFolderPath();
			else
				dlg.SelectedPath		= this.comboBoxFolder.Text;
			dlg.ShowNewFolderButton	= false;
			DialogResult res		= dlg.ShowDialog(this);
			if (res == DialogResult.OK)
				GoToFolder(dlg.SelectedPath);
		}

		private void OnFolderOpen(object sender, System.EventArgs e)
		{
			OpenFolderDialog();
		}

		private void OnSelectedFolder(object sender, System.EventArgs e)
		{
			System.Windows.Forms.MenuItem mi = sender as System.Windows.Forms.MenuItem;
			if (mi != null)
				GoToFolder(menuItemHelp.GetHelpText(mi));
		}

		[DllImport("Shell32.dll")]
		extern static int SHGetFolderPath(IntPtr hwndOwner, int nFolder, IntPtr hToken, UInt32 dwFlags, StringBuilder pszPath);

		private string GetMyPicturesFolderPath()
		{
			StringBuilder sb	= new StringBuilder(256);
			SHGetFolderPath(IntPtr.Zero, 0x27, IntPtr.Zero, 0, sb);
			return sb.ToString();
		}

		private void AddFolderToMenu(Menu m, EventHandler eh, string folder)
		{
			System.Windows.Forms.MenuItem mi	= new System.Windows.Forms.MenuItem();
			menuItemHelp.SetHelpText(mi, folder);
			mi.Text				= Path.GetFileName(folder);
			mi.Click			+= eh;
			m.MenuItems.Add(mi);
		}
		private void OnDropDown(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == this.toolBarButtonOpen)
			{
				Menu m = e.Button.DropDownMenu;
				m.MenuItems.Clear();
				EventHandler eh = new EventHandler(OnSelectedFolder);

				AddFolderToMenu(m, eh, GetMyPicturesFolderPath());
				AddFolderToMenu(m, eh, Environment.GetFolderPath(Environment.SpecialFolder.Personal));
				AddFolderToMenu(m, eh, Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory));

				m.MenuItems.Add("-");

				string [] drives = Environment.GetLogicalDrives();
				foreach (string drive in drives)
				{
					System.Windows.Forms.MenuItem mi	= new System.Windows.Forms.MenuItem();
					menuItemHelp.SetHelpText(mi, drive);
					mi.Text				= drive;
					mi.Click			+= eh;
					m.MenuItems.Add(mi);
				}
			}
		}

		private void OnFolderEditCut(object sender, System.EventArgs e)
		{
			OnFolderEditCopy(sender, e);
			OnFolderEditDelete(sender, e);
		}

		private void OnFolderEditCopy(object sender, System.EventArgs e)
		{
			if (this.comboBoxFolder.SelectionLength > 0)
				Clipboard.SetDataObject(this.comboBoxFolder.SelectedText, true);
		}

		private void OnFolderEditPaste(object sender, System.EventArgs e)
		{
			IDataObject clipData		= Clipboard.GetDataObject();
			if ((clipData != null) && clipData.GetDataPresent(typeof(string)))
			{
				this.comboBoxFolder.SelectedText = (string)clipData.GetData(typeof(string));
			}
		}

		private void OnFolderEditDelete(object sender, System.EventArgs e)
		{
			this.comboBoxFolder.SelectedText = "";
		}

		private void OnFolderEditSelectAll(object sender, System.EventArgs e)
		{
			this.comboBoxFolder.SelectAll();
		}

		private void OnFolderTextPopup(object sender, System.EventArgs e)
		{
			IDataObject clipData		= Clipboard.GetDataObject();
			bool stringInClipboard		= (clipData != null)
				&& clipData.GetDataPresent(typeof(string));
			bool haveSelectedText		= (this.comboBoxFolder.SelectionLength > 0);

			this.menuItemFolderEditCopy.Enabled		= haveSelectedText;
			this.menuItemFolderEditCut.Enabled		= haveSelectedText;
			this.menuItemFolderEditDelete.Enabled	= haveSelectedText;
			this.menuItemFolderEditPaste.Enabled	= stringInClipboard;
		}

		public class FolderChangedEventArgs : EventArgs
		{
			public FolderChangedEventArgs(string folder)
			{
				_folder = folder;
			}

			string _folder;
			public string Folder
			{
				get { return _folder; }
			}
		}

		public delegate void FolderChangedHandler(object sender, FolderChangedEventArgs e);

		public event FolderChangedHandler FolderChanged;

		protected void FireFolderChanged(string folder)
		{
			if (FolderChanged != null)
			{
				FolderChangedEventArgs e = new FolderChangedEventArgs(folder);
				FolderChanged(this, e);
			}
		}

		string _dropFolder;
		private void OnFolderDropDown(object sender, System.EventArgs e)
		{
			if (_currentFolder != _dropFolder)
			{
				_dropFolder = _currentFolder;
				try
				{
					this.comboBoxFolder.BeginUpdate();
					this.comboBoxFolder.Items.Clear();
					if (_dropFolder != string.Empty)
					{
						DirectoryInfo current = new DirectoryInfo(_dropFolder);
						DirectoryInfo parent = current.Parent;
						int startIndex = 0;
						while (parent != null)
						{
							this.comboBoxFolder.Items.Insert(0, parent.FullName);
							parent = parent.Parent;
							startIndex++;
						}
						this.comboBoxFolder.Items.Add(current.FullName);
						DirectoryInfo [] dirs = current.GetDirectories();
						foreach (DirectoryInfo dir in dirs)
						{
							FileAttributes attribs = dir.Attributes;
							const FileAttributes forbidden = FileAttributes.Hidden | FileAttributes.System;
							if ((attribs & forbidden) == 0)
								this.comboBoxFolder.Items.Add(dir.FullName);
						}
						if (startIndex != 0)
							this.comboBoxFolder.SelectedIndex = startIndex;
					}
					else
					{
						this.comboBoxFolder.Items.Add(string.Empty);
					}
				}
				catch (Exception ex)
				{
					Debug.WriteLine(ex.Message);
				}
				finally
				{
					this.comboBoxFolder.EndUpdate();
				}
			}
		}

		private void OnFolderIndexChanged(object sender, System.EventArgs e)
		{
			if (sender == this.comboBoxFolder)
			{
				GoToFolder(this.comboBoxFolder.Text);
			}
		}

		protected override bool ProcessDialogKey(System.Windows.Forms.Keys keyData)
		{
			switch (keyData)
			{
				case Keys.Enter:
					if (this.comboBoxFolder.DroppedDown == false)
					{
						GoToFolder(this.comboBoxFolder.Text);
						return true;
					}
					break;
			}
			return base.ProcessDialogKey(keyData);
		}

		[Browsable(true)]
		public override string Text
		{
			get { return this.comboBoxFolder.Text; }
			set { this.comboBoxFolder.Text = value; }
		}

		public StatusBar StatusBar
		{
			get { return this.menuItemHelp.StatusBar; }
			set { this.menuItemHelp.StatusBar = value; }
		}
	}
}
