using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace iclect.Forms.Utility
{
	/// <summary>
	/// Summary description for MenuItemWithHelp.
	/// </summary>
	public class MenuItemWithHelp : MenuItem
	{
		public MenuItemWithHelp(
			System.Windows.Forms.MenuMerge mergeType,
			System.Int32 mergeOrder,
			System.Windows.Forms.Shortcut shortcut,
			System.String text,
			System.EventHandler onClick,
			System.EventHandler onPopup,
			System.EventHandler onSelect,
			System.Windows.Forms.MenuItem[] items
			) : base(
			mergeType,
			mergeOrder,
			shortcut,
			text,
			onClick,
			onPopup,
			onSelect,
			items
			)
		{
		}
		public MenuItemWithHelp(
			System.String text, System.Windows.Forms.MenuItem[] items
			) : base(text, items)
		{
		}
		public MenuItemWithHelp(
			System.String text,
			System.EventHandler onClick,
			System.Windows.Forms.Shortcut shortcut
			) : base(text, onClick, shortcut)
		{
		}
		public MenuItemWithHelp(
			System.String text,
			System.EventHandler onClick
			) : base(text, onClick)
		{
		}
		public MenuItemWithHelp(System.String text) : base(text)
		{
		}
		public MenuItemWithHelp() : base()
		{
		}

		string _helpText = null;
		[Browsable(true)]
		public string HelpText
		{
			get { return _helpText; }
			set { _helpText = value; }
		}

		StatusBar _statusBar = null;
		[Browsable(true)]
		public StatusBar StatusBar
		{
			get { return _statusBar; }
			set { _statusBar = value; }
		}

		protected override void OnSelect(System.EventArgs e)
		{
			if (_statusBar != null)
			{
				_statusBar.Text = _helpText;
				if (_statusBar.Panels[0] != null)
					_statusBar.Panels[0].Text = _helpText;
			}
		}
	}
}
