using System;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace iclect.ImageManager.Thumbnails
{
	/// <summary>
	/// Summary description for GdiPlusThumbnailer.
	/// </summary>
	public class GdiPlusThumbnailer : Thumbnailer
	{
		private static bool AbortHandler()
		{
			return false;
		}
		private static Image.GetThumbnailImageAbort abort = new Image.GetThumbnailImageAbort(AbortHandler);
		public override Image CreateThumbnail(Image full, int width, int height)
		{
			using (Image mid = full.GetThumbnailImage(width, height, abort, IntPtr.Zero))
			{
				Image thumb = new Bitmap(width, height, mid.PixelFormat);
				using (Graphics g = Graphics.FromImage(thumb))
				{
					g.InterpolationMode	= InterpolationMode.HighQualityBicubic;
					g.DrawImage(mid, 0, 0, width, height);
				}
				return thumb;
			}
		}
	}
}
