using System;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace iclect.ImageManager.Thumbnails
{
	/// <summary>
	/// Summary description for HighQualityThumbnailer.
	/// </summary>
	public class HighQualityThumbnailer : Thumbnailer
	{
		public override Image CreateThumbnail(Image full, int width, int height)
		{
			Image thumb = new Bitmap(width, height, full.PixelFormat);
			using (Graphics g = Graphics.FromImage(thumb))
			{
				g.InterpolationMode	= InterpolationMode.HighQualityBicubic;
				g.DrawImage(full, 0, 0, width, height);
			}
			return thumb;
		}
	}
}
