using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Windows.Forms;

namespace iclect
{
	/// <summary>
	/// Summary description for AboutDialog.
	/// </summary>
	public class AboutDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.PictureBox icon;
		private System.Windows.Forms.RichTextBox richTextBox;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.LinkLabel linkProjectHomepage;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label labelAssembly;
		private System.Windows.Forms.Label labelRuntime;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AboutDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			Assembly assembly = Assembly.GetExecutingAssembly();
			Stream stream = assembly.GetManifestResourceStream("iclect.About.rtf");
			richTextBox.LoadFile(stream, RichTextBoxStreamType.RichText);

			linkProjectHomepage.Links[0].LinkData = "http://iclect.sourceforge.net";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AboutDialog));
			this.buttonOK = new System.Windows.Forms.Button();
			this.labelAssembly = new System.Windows.Forms.Label();
			this.icon = new System.Windows.Forms.PictureBox();
			this.richTextBox = new System.Windows.Forms.RichTextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.linkProjectHomepage = new System.Windows.Forms.LinkLabel();
			this.label1 = new System.Windows.Forms.Label();
			this.labelRuntime = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonOK
			// 
			this.buttonOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonOK.Location = new System.Drawing.Point(360, 324);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 0;
			this.buttonOK.Text = "OK";
			// 
			// labelAssembly
			// 
			this.labelAssembly.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelAssembly.Location = new System.Drawing.Point(168, 320);
			this.labelAssembly.Name = "labelAssembly";
			this.labelAssembly.Size = new System.Drawing.Size(176, 16);
			this.labelAssembly.TabIndex = 1;
			this.labelAssembly.Text = "Version";
			// 
			// icon
			// 
			this.icon.Image = ((System.Drawing.Image)(resources.GetObject("icon.Image")));
			this.icon.Location = new System.Drawing.Point(8, 8);
			this.icon.Name = "icon";
			this.icon.Size = new System.Drawing.Size(48, 48);
			this.icon.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.icon.TabIndex = 2;
			this.icon.TabStop = false;
			// 
			// richTextBox
			// 
			this.richTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.richTextBox.BackColor = System.Drawing.SystemColors.Control;
			this.richTextBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.richTextBox.Cursor = System.Windows.Forms.Cursors.Default;
			this.richTextBox.Location = new System.Drawing.Point(64, 8);
			this.richTextBox.Name = "richTextBox";
			this.richTextBox.Size = new System.Drawing.Size(376, 288);
			this.richTextBox.TabIndex = 3;
			this.richTextBox.Text = "(Text from \"About.rtf\" comes here)";
			// 
			// label2
			// 
			this.label2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label2.Location = new System.Drawing.Point(64, 320);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(104, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Assembly Version:";
			// 
			// linkProjectHomepage
			// 
			this.linkProjectHomepage.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.linkProjectHomepage.LinkArea = new System.Windows.Forms.LinkArea(0, 29);
			this.linkProjectHomepage.Location = new System.Drawing.Point(168, 304);
			this.linkProjectHomepage.Name = "linkProjectHomepage";
			this.linkProjectHomepage.Size = new System.Drawing.Size(176, 16);
			this.linkProjectHomepage.TabIndex = 5;
			this.linkProjectHomepage.TabStop = true;
			this.linkProjectHomepage.Text = "http://iclect.sourceforge.net";
			this.linkProjectHomepage.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.OnClickedHomepage);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label1.Location = new System.Drawing.Point(64, 336);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "Runtime Version:";
			// 
			// labelRuntime
			// 
			this.labelRuntime.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelRuntime.Location = new System.Drawing.Point(168, 336);
			this.labelRuntime.Name = "labelRuntime";
			this.labelRuntime.Size = new System.Drawing.Size(176, 16);
			this.labelRuntime.TabIndex = 1;
			this.labelRuntime.Text = "Version";
			// 
			// label3
			// 
			this.label3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label3.Location = new System.Drawing.Point(64, 304);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(104, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Project Homepage:";
			// 
			// AboutDialog
			// 
			this.AcceptButton = this.buttonOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.buttonOK;
			this.ClientSize = new System.Drawing.Size(450, 359);
			this.Controls.Add(this.linkProjectHomepage);
			this.Controls.Add(this.richTextBox);
			this.Controls.Add(this.icon);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.labelAssembly);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.labelRuntime);
			this.Controls.Add(this.label3);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "AboutDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "About iclect ...";
			this.Load += new System.EventHandler(this.OnLoad);
			this.ResumeLayout(false);

		}
		#endregion

		private void OnLoad(object sender, System.EventArgs e)
		{
			Process proc			= Process.GetCurrentProcess();
			ProcessModule main		= proc.MainModule;
			FileVersionInfo info	= main.FileVersionInfo;
			this.labelAssembly.Text	= info.ProductVersion;

			Assembly assembly		= Assembly.GetAssembly(typeof(Assembly));
			info					= FileVersionInfo.GetVersionInfo(assembly.Location);
			this.labelRuntime.Text	= info.ProductVersion;
		}

		private void OnClickedHomepage(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			e.Link.Visited = true;
			string url = e.Link.LinkData.ToString();
			Process.Start(url);
		}
	}
}
