using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Windows.Forms;

using iclect.Forms;
using iclect.Forms.Utility;
using iclect.ImageManager;

namespace iclect
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : Form
	{
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuFileOpenFolder;
		private System.Windows.Forms.MenuItem menuFileSep1;
		private System.Windows.Forms.MenuItem menuFileExit;
		private System.Windows.Forms.MenuItem menuEdit;
		private System.Windows.Forms.MenuItem menuEditSelectAll;
		private System.Windows.Forms.MenuItem menuEditSelectAllImages;
		private System.Windows.Forms.MenuItem menuEditUnselectAll;
		private System.Windows.Forms.MenuItem menuEditSep1;
		private System.Windows.Forms.MenuItem menuEditReverseSelection;
		private System.Windows.Forms.MenuItem menuEditReverseImageSelection;
		private System.Windows.Forms.MenuItem menuImages;
		private System.Windows.Forms.MenuItem menuImagesCopyTo;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuHelpKeyboard;
		private System.Windows.Forms.MenuItem menuHelpSep1;
		private System.Windows.Forms.MenuItem menuHelpAbout;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.Panel panelTop;
		private System.Windows.Forms.Label labelAddressBar;
		private iclect.Forms.AddressBar addressBar;
		private System.Windows.Forms.Panel panelCenter;
		private iclect.Forms.Film film;
		private iclect.Forms.ImagePreview imagePreview;
		private System.Windows.Forms.StatusBar statusBar;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.StatusBarPanel statusBarText;
		private System.Windows.Forms.StatusBarPanel statusBarCount;
		private System.Windows.Forms.StatusBarPanel statusBarSelected;
		private System.Windows.Forms.StatusBarPanel statusBarPosition;
		private iclect.Forms.Utility.MenuItemHelp menuItemHelp;

		string _title;
		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			_title = this.Text;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.statusBarText = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPosition = new System.Windows.Forms.StatusBarPanel();
			this.statusBarCount = new System.Windows.Forms.StatusBarPanel();
			this.statusBarSelected = new System.Windows.Forms.StatusBarPanel();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuFileOpenFolder = new System.Windows.Forms.MenuItem();
			this.menuFileSep1 = new System.Windows.Forms.MenuItem();
			this.menuFileExit = new System.Windows.Forms.MenuItem();
			this.menuEdit = new System.Windows.Forms.MenuItem();
			this.menuEditSelectAll = new System.Windows.Forms.MenuItem();
			this.menuEditSelectAllImages = new System.Windows.Forms.MenuItem();
			this.menuEditUnselectAll = new System.Windows.Forms.MenuItem();
			this.menuEditSep1 = new System.Windows.Forms.MenuItem();
			this.menuEditReverseSelection = new System.Windows.Forms.MenuItem();
			this.menuEditReverseImageSelection = new System.Windows.Forms.MenuItem();
			this.menuImages = new System.Windows.Forms.MenuItem();
			this.menuImagesCopyTo = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuHelpKeyboard = new System.Windows.Forms.MenuItem();
			this.menuHelpSep1 = new System.Windows.Forms.MenuItem();
			this.menuHelpAbout = new System.Windows.Forms.MenuItem();
			this.addressBar = new iclect.Forms.AddressBar();
			this.labelAddressBar = new System.Windows.Forms.Label();
			this.film = new iclect.Forms.Film();
			this.imagePreview = new iclect.Forms.ImagePreview();
			this.panelTop = new System.Windows.Forms.Panel();
			this.panelCenter = new System.Windows.Forms.Panel();
			this.menuItemHelp = new iclect.Forms.Utility.MenuItemHelp(this.components);
			((System.ComponentModel.ISupportInitialize)(this.statusBarText)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPosition)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarCount)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarSelected)).BeginInit();
			this.panelTop.SuspendLayout();
			this.panelCenter.SuspendLayout();
			this.SuspendLayout();
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 499);
			this.statusBar.Name = "statusBar";
			this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						 this.statusBarText,
																						 this.statusBarPosition,
																						 this.statusBarCount,
																						 this.statusBarSelected});
			this.statusBar.ShowPanels = true;
			this.statusBar.Size = new System.Drawing.Size(712, 22);
			this.statusBar.TabIndex = 0;
			this.statusBar.Text = "Ready.";
			// 
			// statusBarText
			// 
			this.statusBarText.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarText.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None;
			this.statusBarText.Text = "Ready.";
			this.statusBarText.Width = 606;
			// 
			// statusBarPosition
			// 
			this.statusBarPosition.Alignment = System.Windows.Forms.HorizontalAlignment.Center;
			this.statusBarPosition.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.statusBarPosition.Text = "n/a";
			this.statusBarPosition.ToolTipText = "Current position in the folder.";
			this.statusBarPosition.Width = 30;
			// 
			// statusBarCount
			// 
			this.statusBarCount.Alignment = System.Windows.Forms.HorizontalAlignment.Center;
			this.statusBarCount.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.statusBarCount.Text = "n/a";
			this.statusBarCount.ToolTipText = "Number of files in the folder.";
			this.statusBarCount.Width = 30;
			// 
			// statusBarSelected
			// 
			this.statusBarSelected.Alignment = System.Windows.Forms.HorizontalAlignment.Center;
			this.statusBarSelected.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.statusBarSelected.Text = "n/a";
			this.statusBarSelected.ToolTipText = "Number of selected file in the folder.";
			this.statusBarSelected.Width = 30;
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFile,
																					 this.menuEdit,
																					 this.menuImages,
																					 this.menuHelp});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFileOpenFolder,
																					 this.menuFileSep1,
																					 this.menuFileExit});
			this.menuFile.Text = "&File";
			// 
			// menuFileOpenFolder
			// 
			this.menuItemHelp.SetHelpText(this.menuFileOpenFolder, "Open a folder for viewing.");
			this.menuFileOpenFolder.Index = 0;
			this.menuFileOpenFolder.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.menuFileOpenFolder.Text = "&Open Folder...";
			this.menuFileOpenFolder.Click += new System.EventHandler(this.OnFileOpenFolder);
			// 
			// menuFileSep1
			// 
			this.menuFileSep1.Index = 1;
			this.menuFileSep1.Text = "-";
			// 
			// menuFileExit
			// 
			this.menuItemHelp.SetHelpText(this.menuFileExit, "Exit iclect.");
			this.menuFileExit.Index = 2;
			this.menuFileExit.Text = "E&xit";
			this.menuFileExit.Click += new System.EventHandler(this.OnFileExit);
			// 
			// menuEdit
			// 
			this.menuEdit.Index = 1;
			this.menuEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuEditSelectAll,
																					 this.menuEditSelectAllImages,
																					 this.menuEditUnselectAll,
																					 this.menuEditSep1,
																					 this.menuEditReverseSelection,
																					 this.menuEditReverseImageSelection});
			this.menuEdit.Text = "&Edit";
			this.menuEdit.Popup += new System.EventHandler(this.OnMenuPopup);
			// 
			// menuEditSelectAll
			// 
			this.menuItemHelp.SetHelpText(this.menuEditSelectAll, "Select all files.");
			this.menuEditSelectAll.Index = 0;
			this.menuEditSelectAll.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
			this.menuEditSelectAll.Text = "Select &All";
			this.menuEditSelectAll.Click += new System.EventHandler(this.OnEditSelectAll);
			// 
			// menuEditSelectAllImages
			// 
			this.menuItemHelp.SetHelpText(this.menuEditSelectAllImages, "Select all images.");
			this.menuEditSelectAllImages.Index = 1;
			this.menuEditSelectAllImages.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftA;
			this.menuEditSelectAllImages.Text = "Select All &Images";
			this.menuEditSelectAllImages.Click += new System.EventHandler(this.OnEditSelectAllImages);
			// 
			// menuEditUnselectAll
			// 
			this.menuItemHelp.SetHelpText(this.menuEditUnselectAll, "Unselect all.");
			this.menuEditUnselectAll.Index = 2;
			this.menuEditUnselectAll.Shortcut = System.Windows.Forms.Shortcut.CtrlU;
			this.menuEditUnselectAll.Text = "&Unselect All";
			this.menuEditUnselectAll.Click += new System.EventHandler(this.OnEditUnselectAll);
			// 
			// menuEditSep1
			// 
			this.menuEditSep1.Index = 3;
			this.menuEditSep1.Text = "-";
			// 
			// menuEditReverseSelection
			// 
			this.menuItemHelp.SetHelpText(this.menuEditReverseSelection, "Reverse the selection.");
			this.menuEditReverseSelection.Index = 4;
			this.menuEditReverseSelection.Shortcut = System.Windows.Forms.Shortcut.CtrlR;
			this.menuEditReverseSelection.Text = "&Reverse Selection";
			this.menuEditReverseSelection.Click += new System.EventHandler(this.OnEditReverseSelection);
			// 
			// menuEditReverseImageSelection
			// 
			this.menuItemHelp.SetHelpText(this.menuEditReverseImageSelection, "Reverse the selection of images only.");
			this.menuEditReverseImageSelection.Index = 5;
			this.menuEditReverseImageSelection.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftR;
			this.menuEditReverseImageSelection.Text = "Re&verse Image Selection";
			this.menuEditReverseImageSelection.Click += new System.EventHandler(this.OnEditReverseImageSelection);
			// 
			// menuImages
			// 
			this.menuImages.Index = 2;
			this.menuImages.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuImagesCopyTo});
			this.menuImages.Text = "&Images";
			this.menuImages.Popup += new System.EventHandler(this.OnMenuPopup);
			// 
			// menuImagesCopyTo
			// 
			this.menuItemHelp.SetHelpText(this.menuImagesCopyTo, "Copy selected images to a folder.");
			this.menuImagesCopyTo.Index = 0;
			this.menuImagesCopyTo.Shortcut = System.Windows.Forms.Shortcut.CtrlF;
			this.menuImagesCopyTo.Text = "&Copy to...";
			this.menuImagesCopyTo.Click += new System.EventHandler(this.OnImagesCopyToFolder);
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 3;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuHelpKeyboard,
																					 this.menuHelpSep1,
																					 this.menuHelpAbout});
			this.menuHelp.Text = "&Help";
			// 
			// menuHelpKeyboard
			// 
			this.menuItemHelp.SetHelpText(this.menuHelpKeyboard, "Show keyboard help.");
			this.menuHelpKeyboard.Index = 0;
			this.menuHelpKeyboard.Shortcut = System.Windows.Forms.Shortcut.F1;
			this.menuHelpKeyboard.Text = "&Keyboard...";
			this.menuHelpKeyboard.Click += new System.EventHandler(this.OnHelpKeyboard);
			// 
			// menuHelpSep1
			// 
			this.menuHelpSep1.Index = 1;
			this.menuHelpSep1.Text = "-";
			// 
			// menuHelpAbout
			// 
			this.menuItemHelp.SetHelpText(this.menuHelpAbout, "Show info about iclect.");
			this.menuHelpAbout.Index = 2;
			this.menuHelpAbout.Text = "&About...";
			this.menuHelpAbout.Click += new System.EventHandler(this.OnHelpAbout);
			// 
			// addressBar
			// 
			this.addressBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.addressBar.AutoScroll = true;
			this.addressBar.Location = new System.Drawing.Point(72, 0);
			this.addressBar.Name = "addressBar";
			this.addressBar.Size = new System.Drawing.Size(632, 26);
			this.addressBar.StatusBar = this.statusBar;
			this.addressBar.TabIndex = 1;
			this.addressBar.FolderChanged += new iclect.Forms.AddressBar.FolderChangedHandler(this.OnFolderChanged);
			// 
			// labelAddressBar
			// 
			this.labelAddressBar.Location = new System.Drawing.Point(8, 0);
			this.labelAddressBar.Name = "labelAddressBar";
			this.labelAddressBar.Size = new System.Drawing.Size(56, 23);
			this.labelAddressBar.TabIndex = 0;
			this.labelAddressBar.Text = "&Folder:";
			this.labelAddressBar.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// film
			// 
			this.film.BackColor = System.Drawing.SystemColors.AppWorkspace;
			this.film.Dock = System.Windows.Forms.DockStyle.Left;
			this.film.FilmColor = System.Drawing.Color.Black;
			this.film.FocusColor = System.Drawing.Color.Blue;
			this.film.FocusedThumbIndex = -1;
			this.film.ForeColor = System.Drawing.Color.White;
			this.film.ImageFolder = null;
			this.film.Location = new System.Drawing.Point(0, 0);
			this.film.Name = "film";
			this.film.Orientation = System.Windows.Forms.Orientation.Vertical;
			this.film.ScrollValue = 0;
			this.film.SelectedFocusColor = System.Drawing.Color.Lime;
			this.film.SelectionColor = System.Drawing.Color.Yellow;
			this.film.Size = new System.Drawing.Size(116, 471);
			this.film.TabIndex = 1;
			this.film.ThumbSize = 96;
			this.film.ThumbChanged += new iclect.Forms.Film.ThumbChangedHandler(this.OnThumbChanged);
			// 
			// imagePreview
			// 
			this.imagePreview.BackColor = System.Drawing.SystemColors.AppWorkspace;
			this.imagePreview.Center = true;
			this.imagePreview.Dock = System.Windows.Forms.DockStyle.Fill;
			this.imagePreview.ImageReference = null;
			this.imagePreview.Location = new System.Drawing.Point(116, 0);
			this.imagePreview.Name = "imagePreview";
			this.imagePreview.Size = new System.Drawing.Size(592, 471);
			this.imagePreview.TabIndex = 2;
			// 
			// panelTop
			// 
			this.panelTop.BackColor = System.Drawing.SystemColors.Control;
			this.panelTop.Controls.Add(this.labelAddressBar);
			this.panelTop.Controls.Add(this.addressBar);
			this.panelTop.Dock = System.Windows.Forms.DockStyle.Top;
			this.panelTop.Location = new System.Drawing.Point(0, 0);
			this.panelTop.Name = "panelTop";
			this.panelTop.Size = new System.Drawing.Size(712, 24);
			this.panelTop.TabIndex = 0;
			// 
			// panelCenter
			// 
			this.panelCenter.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panelCenter.Controls.Add(this.imagePreview);
			this.panelCenter.Controls.Add(this.film);
			this.panelCenter.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelCenter.Location = new System.Drawing.Point(0, 24);
			this.panelCenter.Name = "panelCenter";
			this.panelCenter.Size = new System.Drawing.Size(712, 475);
			this.panelCenter.TabIndex = 3;
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.StatusBar = this.statusBar;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.AppWorkspace;
			this.ClientSize = new System.Drawing.Size(712, 521);
			this.Controls.Add(this.panelCenter);
			this.Controls.Add(this.panelTop);
			this.Controls.Add(this.statusBar);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.MinimumSize = new System.Drawing.Size(288, 216);
			this.Name = "MainForm";
			this.Text = "iclect";
			this.MenuStart += new System.EventHandler(this.OnMenuStart);
			this.MenuComplete += new System.EventHandler(this.OnMenuComplete);
			((System.ComponentModel.ISupportInitialize)(this.statusBarText)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPosition)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarCount)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarSelected)).EndInit();
			this.panelTop.ResumeLayout(false);
			this.panelCenter.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Commands
		private void OnFileExit(object sender, System.EventArgs e)
		{
			Application.Exit();
		}
		private void OnHelpAbout(object sender, System.EventArgs e)
		{
			AboutDialog dlg = new AboutDialog();
			dlg.ShowDialog();
		}
		#endregion

		#region Status Bar
		string _savedStatusBarText;
		private void OnMenuStart(object sender, System.EventArgs e)
		{
			_savedStatusBarText = this.statusBar.Text;
		}
		private void OnMenuComplete(object sender, System.EventArgs e)
		{
			this.statusBar.Text		= _savedStatusBarText;
			this.statusBarText.Text	= _savedStatusBarText;
		}
		#endregion


		private void OnFolderChanged(object sender, AddressBar.FolderChangedEventArgs e)
		{
			film.SuspendLayout();
			try
			{
				this.Text = _title;
				this.statusBar.SuspendLayout();
				this.statusBar.ShowPanels = false;

				if (imagePreview.ImageReference != null)
				{
					Debug.WriteLine("Releasing preview reference!");
					ImageReference imageReference = imagePreview.ImageReference;
					imagePreview.ImageReference = null;
					imageReference.Dispose();
				}

				if (film.ImageFolder != null)
				{
					Debug.WriteLine("Releasing image folder!");
					ImageFolder imageFolder = film.ImageFolder;
					film.ImageFolder = null;
					imageFolder.Dispose();
				}

				string path = e.Folder;
				if (path != string.Empty)
				{
					Debug.WriteLine(path);
					this.Text = string.Format("{0} - {1}",
						Path.GetFileName(path),
						_title);
					ImageFolder imageFolder = new ImageFolder(path);
					this.statusBarCount.Text = imageFolder.ImageFiles.Length.ToString();
					film.ImageFolder = imageFolder;
					film.Focus();
					this.statusBar.ShowPanels = true;
				}
			}
			finally
			{
				film.ResumeLayout();
				this.statusBar.ResumeLayout();
			}
		}

		private void OnThumbChanged(object sender, Film.ThumbChangedEventArgs e)
		{
			if (imagePreview.ImageReference != null)
			{
				Debug.WriteLine("Releasing preview reference!");
				ImageReference imageReference = imagePreview.ImageReference;
				imagePreview.ImageReference = null;
				imageReference.Dispose();
			}

			ImageFile imageFile = e.ImageFile;
			if (imageFile != null)
			{
				Debug.WriteLine(imageFile.Name);
				imagePreview.ImageReference = imageFile.GetImageReference();
			}
			int index = e.Index;
			if (index >= 0)
			{
				this.statusBarPosition.Text = (index + 1).ToString();
			}
		}

		private void OnFileOpenFolder(object sender, System.EventArgs e)
		{
			addressBar.OpenFolderDialog();
		}

		private void OnEditSelectAll(object sender, System.EventArgs e)
		{
			film.SelectAll(false);
		}

		private void OnEditSelectAllImages(object sender, System.EventArgs e)
		{
			film.SelectAll(true);
		}

		private void OnEditUnselectAll(object sender, System.EventArgs e)
		{
			film.UnselectAll();
		}

		private void OnEditReverseSelection(object sender, System.EventArgs e)
		{
			film.ReverseSelection(false);
		}

		private void OnEditReverseImageSelection(object sender, System.EventArgs e)
		{
			film.ReverseSelection(true);
		}

		private void OnImagesCopyToFolder(object sender, System.EventArgs e)
		{
			if ((addressBar.Text == string.Empty)
				|| (film.ImageFolder == null))
				return;
						
			string selectedFolder = addressBar.Text;
			while (true)
			{
				iclect.Forms.Utility.FolderBrowserDialog dlg = new iclect.Forms.Utility.FolderBrowserDialog();
				dlg.ShowNewFolderButton	= true;
				dlg.SelectedPath		= selectedFolder;
				DialogResult res		= dlg.ShowDialog(this);
				if (res != DialogResult.OK)
					return;
				if (dlg.SelectedPath != selectedFolder)
				{
					selectedFolder = dlg.SelectedPath;
					break;
				}
				res = MessageBox.Show(this, "Select a target folder that is different from the source folder", "iclect - Conflict", MessageBoxButtons.OKCancel);
				if (res != DialogResult.OK)
					return;
			}

			foreach (ImageFile imageFile in film.ImageFolder.SelectedImageFiles)
			{
				string source = imageFile.FullName;
				string target = Path.Combine(selectedFolder, imageFile.Name);
				try
				{
					File.Copy(source, target, false);
					File.SetAttributes(target, FileAttributes.Normal);
				}
				catch (Exception ex)
				{
					Debug.WriteLine(ex.Message);
				}
			}
		}

		private void OnHelpKeyboard(object sender, System.EventArgs e)
		{
			KeyboardHelpForm dlg = new KeyboardHelpForm();
			dlg.ShowDialog(this);
		}

		private void OnMenuPopup(object sender, System.EventArgs e)
		{
			bool haveImages = (film.ImageCount > 0);
			menuEditSelectAll.Enabled				= haveImages;
			menuEditSelectAllImages.Enabled			= haveImages;
			menuEditUnselectAll.Enabled				= haveImages;
			menuEditReverseSelection.Enabled		= haveImages;
			menuEditReverseImageSelection.Enabled	= haveImages;
			menuImagesCopyTo.Enabled				= haveImages
				&& (film.ImageFolder.SelectedIndices.Length > 0);
		}
	}
}
